unit U_CustInput;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, cxGraphics, cxCustomData, cxStyles, cxTL, cxMaskEdit, DB, ADODB,
  cxInplaceContainer, cxDBTL, cxControls, cxTLData, ComCtrls, ToolWin, StdCtrls,
  cxFilter, cxData, cxDataStorage, cxEdit, cxDBData, DBClient,
  cxGridCustomTableView, cxGridTableView, cxGridDBTableView, ExtCtrls,
  cxSplitter, cxGridLevel, cxClasses, cxGridCustomView, cxGrid,
  cxGridCustomPopupMenu, cxGridPopupMenu, RM_Dataset, RM_System, RM_Common,
  RM_Class, RM_GridReport, IdBaseComponent, IdComponent, IdTCPConnection,
  IdTCPClient, IdFTP, ShellAPI, IniFiles, cxCheckBox, cxCalendar, cxButtonEdit,
  cxTextEdit, cxDropDownEdit, BtnEdit, cxLookAndFeels, cxLookAndFeelPainters,
  cxNavigator, dxDateRanges, dxBarBuiltInMenu, U_BaseInput, System.ImageList,
  Vcl.ImgList, cxContainer, cxMemo, dxScrollbarAnnotations, cxImageList,
  dxSkinsCore, dxSkinsDefaultPainters, dxSkinWXI, dxCoreGraphics;

type
  TfrmCustInput = class(TfrmBaseInput)
    ToolBar1: TToolBar;
    TBClose: TToolButton;
    ADOQueryTemp: TADOQuery;
    ADOQueryCmd: TADOQuery;
    ADOQueryMain: TADOQuery;
    cxGridPopupMenu2: TcxGridPopupMenu;
    ToolButton3: TToolButton;
    CDS_LXR: TClientDataSet;
    DSLXR: TDataSource;
    ScrollBox1: TScrollBox;
    Label2: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    CoName: TcxTextEdit;
    Label1: TLabel;
    CoAbbrName: TcxTextEdit;
    CoCode: TcxTextEdit;
    Panel1: TPanel;
    Label4: TLabel;
    Label8: TLabel;
    Panel3: TPanel;
    ToolBar3: TToolBar;
    ToolButton2: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    cxGrid2: TcxGrid;
    TV2: TcxGridDBTableView;
    cxGridDBColumn2: TcxGridDBColumn;
    cxGridDBColumn3: TcxGridDBColumn;
    cxGridDBColumn5: TcxGridDBColumn;
    cxGridDBColumn6: TcxGridDBColumn;
    cxGridDBColumn7: TcxGridDBColumn;
    cxGridDBColumn8: TcxGridDBColumn;
    cxGridLevel2: TcxGridLevel;
    Label10: TLabel;
    TV2Column2: TcxGridDBColumn;
    Label3: TLabel;
    Label5: TLabel;
    CoBusinessType: TcxButtonEdit;
    cocountry: TcxButtonEdit;
    CoLevel: TcxComboBox;
    ParentCoName: TcxButtonEdit;
    ToolButton1: TToolButton;
    CoAddress: TcxTextEdit;
    CoNote: TcxMemo;
    Label9: TLabel;
    ShuiNo: TcxTextEdit;
    Label11: TLabel;
    BankName: TcxButtonEdit;
    Label12: TLabel;
    BankNo: TcxTextEdit;
    Label13: TLabel;
    BankCode: TcxTextEdit;
    Label14: TLabel;
    YHDZ: TcxTextEdit;
    Label15: TLabel;
    SC: TcxTextEdit;
    BillCycle: TcxTextEdit;
    Label16: TLabel;
    Label17: TLabel;
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TBCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TBRafreshClick(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure ToolButton6Click(Sender: TObject);
    procedure ToolButton7Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure BuyNamePropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
    procedure CoBusinessTypeDblClick(Sender: TObject);
    procedure cxButtonEdit1PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
    procedure ToolButton1Click(Sender: TObject);
  private
    { Private declarations }
    procedure InitGrid();
    function SaveData(): Boolean;
  public
    fkhType: string;
    { Public declarations }
    FCOID: string;
  end;

var
  frmCustInput: TfrmCustInput;

implementation

uses
  U_DataLink, U_RTFun, U_ZDYHelp, U_YGSel, U_CompanySel;

{$R *.dfm}

procedure TfrmCustInput.InitGrid();
begin
  try

    ADOQueryMain.DisableControls;
    with ADOQueryMain do
    begin
      Filtered := False;
      Close;
      SQL.Clear;
      sql.Add(' select * from BS_Company where  CoType=''客户'' and COID=''' + Trim(FCOID) + '''');
      Open;
    end;
    SCSHData(ADOQueryMain, ScrollBox1, 2);
    ParentCoName.Properties.LookupItems.Text := ADOQueryMain.FieldByName('ParentCoCode').AsString;
    with ADOQueryMain do
    begin
      Filtered := False;
      Close;
      SQL.Clear;
      sql.Add(' select * from BS_Company_contact where COID=' + quotedstr(Trim(FCOID)));
      Open;
    end;
    SCreateCDS(ADOQueryMain, CDS_LXR);
    SInitCDSData(ADOQueryMain, CDS_LXR);

  finally
    ADOQueryMain.EnableControls;
  end;
end;

procedure TfrmCustInput.FormDestroy(Sender: TObject);
begin
  inherited;
  frmCustInput := nil;
end;

procedure TfrmCustInput.BuyNamePropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
var
  fsj: string;
  FWZ: Integer;
begin
  fsj := Trim(TcxButtonEdit(Sender).Hint);
  FWZ := Pos('/', fsj);
  try
    frmZDYHelp := TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      MainType := 'Cust';
      flag := Copy(fsj, 1, FWZ - 1);
      flagname := Copy(fsj, FWZ + 1, Length(fsj) - FWZ);
      if ShowModal = 1 then
      begin
        TcxButtonEdit(Sender).Text := Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmCustInput.CoBusinessTypeDblClick(Sender: TObject);
begin
  TcxButtonEdit(Sender).Text := '';
  TcxButtonEdit(Sender).Properties.LookupItems.Text := '';
end;

procedure TfrmCustInput.cxButtonEdit1PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
begin
  try
    frmCompanySel := TfrmCompanySel.Create(Application);
    with frmCompanySel do
    begin
      FCoType := '客户';
      if ShowModal = 1 then
      begin
        self.ParentCoName.Text := Trim(CDS_1.fieldbyname('CoAbbrName').AsString);
        self.ParentCoName.Properties.LookupItems.Text := Trim(CDS_1.fieldbyname('CoCode').AsString);
      end;
    end;
  finally
    frmCompanySel.Free;
  end;
end;

procedure TfrmCustInput.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  inherited;
  Action := caFree;
end;

procedure TfrmCustInput.TBCloseClick(Sender: TObject);
begin
  WriteCxGrid(trim(self.Caption) + 'TV2', Tv2, '供应商管理');

  close;
end;

procedure TfrmCustInput.FormShow(Sender: TObject);
var
  i: integer;
  a: string;
begin
  inherited;
  ReadCxGrid(trim(self.caption) + 'Tv2', Tv2, '客户管理');
  InitGrid();
  if trim(FCOID) = '' then
  begin
    with ADOQueryTemp do
    begin
      Close;
      sql.Clear;
      sql.Add(' exec P_BS_Com_Get_No @Str=''K'' ');
      Open;
    end;
    CoCode.Text := trim(ADOQueryTemp.FieldByName('NewCoCode').asstring);
  end;
   //已审核的也要能修改保存，不能修改主表内容，只能改下面两部分
  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    sql.Add(' select * from BS_Company where CoId=' + quotedstr(FCoId));
    Open;
  end;
  if trim(ADOQueryTemp.FieldByName('Status').asstring) = '1' then
  begin
    ScrollBox1.Enabled := False;
  end;
end;

procedure TfrmCustInput.TBRafreshClick(Sender: TObject);
begin
  InitGrid();
end;

function TfrmCustInput.SaveData(): Boolean;
var
  MaxId, MaxSubId, FCoCode, FCCID: string;
begin
  try
    ADOQueryCmd.Connection.BeginTrans;
    if Trim(FCOID) = '' then
    begin
      if GetLSNo(ADOQueryCmd, MaxId, 'CO', 'BS_Company', 4, 1) = False then
      begin
        Result := False;
        ADOQueryCmd.Connection.RollbackTrans;
        Application.MessageBox('取最大号失败！', '提示', 0);
        Exit;
      end;

      with ADOQueryTemp do
      begin
        Close;
        sql.Clear;
        sql.Add(' exec P_BS_Com_Get_No @Str=''K'' ');
        Open;
      end;
      CoCode.Text := trim(ADOQueryTemp.FieldByName('NewCoCode').asstring);

    end
    else
    begin
      MaxId := Trim(FCOID);
    end;

    with ADOQueryCmd do
    begin
      Close;
      SQL.Clear;
      sql.Add('select * from BS_Company where COID=''' + Trim(FCOID) + '''');
      Open;
    end;
    with ADOQueryCmd do
    begin
      if Trim(FCOID) = '' then
      begin
        Append;
        FieldByName('FillId').Value := Trim(DCode);
        FieldByName('Filler').Value := Trim(DName);
        FieldByName('Saleser').Value := trim(DName);
        FieldByName('SalesId').Value := trim(DCode);
        FieldByName('Tallyer').Value := trim(DName);
        FieldByName('TallyId').Value := trim(DCode);
        FieldByName('status').Value := '0';
      end
      else
      begin
        Edit;
        FieldByName('EditId').Value := Trim(DCode);
        FieldByName('Editer').Value := Trim(DName);
        FieldByName('Edittime').Value := SGetServerDateTime(ADOQueryTemp);
      end;
      FieldByName('COID').Value := Trim(MaxId);
      RTSetsavedata(ADOQueryCmd, 'BS_Company', ScrollBox1, 2);
      FieldByName('CoType').Value := '客户';
      FieldByName('ParentCoCode').Value := ParentCoName.Properties.LookupItems.Text;
      Post;
    end;

    with ADOQueryCmd do
    begin
      Close;
      sql.Clear;
      sql.Add('select * from BS_Company where CoCode=' + quotedstr(trim(CoCode.Text)));
      Open;
    end;
    if ADOQueryCmd.RecordCount > 1 then
    begin
      ADOQueryCmd.Connection.RollbackTrans;
      Application.MessageBox('编号重复!', '提示', 0);
      Exit;
    end;

    with ADOQueryCmd do
    begin
      Close;
      sql.Clear;
      sql.Add('select * from BS_Company where CoName=' + quotedstr(trim(CoName.Text)));
      sql.Add(' and CoType=''客户''    ');
      Open;
    end;
    if ADOQueryCmd.RecordCount > 1 then
    begin
      ADOQueryCmd.Connection.RollbackTrans;
      Application.MessageBox('名称重复!', '提示', 0);
      Exit;
    end;

    with ADOQueryCmd do
    begin
      Close;
      sql.Clear;
      sql.Add('select * from BS_Company where CoAbbrName=' + quotedstr(trim(CoAbbrName.Text)));
      sql.Add(' and CoType=''客户''    ');
      Open;
    end;
    if ADOQueryCmd.RecordCount > 1 then
    begin
      ADOQueryCmd.Connection.RollbackTrans;
      Application.MessageBox('简称重复!', '提示', 0);
      Exit;
    end;
//////////////            联系人              ///////////////////
    if not CDS_LXR.IsEmpty then
    begin
      with CDS_LXR do
      begin
        CDS_LXR.First;
        while not Eof do
        begin
          FCCID := Trim(CDS_LXR.fieldbyname('CCID').AsString);
          if Trim(FCCID) = '' then
          begin
            if GetLSNo(ADOQueryCmd, MaxSubId, 'CCS', 'BS_Company_contact', 4, 1) = False then
            begin
              ADOQueryCmd.Connection.RollbackTrans;
              Application.MessageBox('取系人最大ID失败!', '提示', 0);
              Exit;
            end;
          end
          else
          begin
            MaxSubId := trim(FCCID);
          end;

          with ADOQueryCmd do
          begin
            Close;
            sql.Clear;
            sql.Add('select * from BS_Company_contact where CCID=' + quotedstr(Trim(MaxSubId)));
            Open;
          end;
          with ADOQueryCmd do
          begin
            if Trim(FCCID) = '' then
            begin
              Append;
            end
            else
            begin
              Edit;
            end;
            FieldByName('CCID').Value := Trim(MaxSubId);
            FieldByName('COID').Value := Trim(MaxId);
            RTSetSaveDataCDS(ADOQueryCmd, Tv2, CDS_LXR, 'BS_Company_contact', 0);
            Post;
          end;
          with CDS_LXR do
          begin
            Edit;
            FieldByName('CCID').Value := Trim(MaxSubId);
            Post;
          end;
          CDS_LXR.Next;
        end;
      end;
    end;
//////////////            联系人              ///////////////////
////////////////         更新名称          ////////////////////////
//    with ADOQueryCmd do
//    begin
//      Close;
//      sql.Clear;
//      sql.Add('exec P_Com_Up_Code @COID=' + quotedstr(Trim(MaxId)));
//      ExecSQL;
//    end;
////////////////         更新名称          ////////////////////////
    ADOQueryCmd.Connection.CommitTrans;
    FCCID := Trim(MaxSubId);
    Result := True;
  except
    Result := false;
    ADOQueryCmd.Connection.RollbackTrans;
    Application.MessageBox('保存异常!', '提示', 0);
  end;
end;

procedure TfrmCustInput.ToolButton3Click(Sender: TObject);
begin

  if Trim(CoAbbrName.Text) = '' then
  begin
    Application.MessageBox('简称不能为空!', '提示', 0);
    Exit;
  end;
  if Trim(CoName.Text) = '' then
  begin
    Application.MessageBox('名称不能为空!', '提示', 0);
    Exit;
  end;
  if SaveData() then
  begin
    Application.MessageBox('保存成功!', '提示', 0);
    ModalResult := 1;
  end;
end;

procedure TfrmCustInput.ToolButton6Click(Sender: TObject);
var
  maxno: string;
begin
  if GetLSNo(ADOQueryCmd, maxno, 'CC', 'BS_Company_contact', 4, 1) = False then
  begin
    Application.MessageBox('取系人最大ID失败!', '提示', 0);
    Exit;
  end;
  if CDS_LXR.IsEmpty then
  begin
    with CDS_LXR do
    begin
      Append;
      fieldbyname('CCID').Value := trim(maxno);
      fieldbyname('IsDefault').Value := true;
      Post;
    end;
  end
  else
  begin
    with CDS_LXR do
    begin
      Append;
      fieldbyname('CCID').Value := trim(maxno);
      fieldbyname('IsDefault').Value := false;
      Post;
    end;
  end;

end;

procedure TfrmCustInput.ToolButton7Click(Sender: TObject);
begin
  if CDS_LXR.IsEmpty then
    Exit;
  if Trim(CDS_LXR.fieldbyname('CCID').AsString) <> '' then
  begin
    if Application.MessageBox('确定要删除数据吗？', '提示', 32 + 4) <> IDYES then
      Exit;
    with ADOQueryCmd do
    begin
      Close;
      sql.Clear;
      sql.Add('delete from BS_Company_contact where CCID=''' + Trim(CDS_LXR.fieldbyname('CCID').AsString) + '''');
      ExecSQL;
    end;
  end;
  CDS_LXR.Delete;
  if CDS_LXR.IsEmpty = false then
  begin
    if CDS_LXR.Locate('IsDefault', true, []) = false then
    begin
      CDS_LXR.first;
      CDS_LXR.edit;
      CDS_LXR.FieldByName('IsDefault').value := true;
    end;
  end;

end;

procedure TfrmCustInput.ToolButton1Click(Sender: TObject);
begin
  WriteCxGrid(trim(self.caption) + 'Tv2', Tv2, '客户管理');
end;

procedure TfrmCustInput.ToolButton2Click(Sender: TObject);
var
  DwFlag: string;
begin
  DwFlag := trim(CDS_LXR.FieldByName('CCID').AsString);
  if CDS_LXR.Locate('IsDefault', true, []) then
  begin
    CDS_LXR.edit;
    CDS_LXR.FieldByName('IsDefault').value := false;
  end;
  if CDS_LXR.Locate('CCID', DwFlag, []) then
  begin
    CDS_LXR.edit;
    CDS_LXR.FieldByName('IsDefault').value := true;
  end;

end;

end.

